
// example presented in paragraph 7.8 of the manual
// https://maniFEM.rd.ciencias.ulisboa.pt/manual-maniFEM.pdf
// a skew flat torus again

#include "maniFEM.h"

using namespace maniFEM;


int main ( )

{	// begin with the usual two-dimensional space
	Manifold RR2 ( tag::Euclid, tag::of_dim, 2 );
	Function xy = RR2 .build_coordinate_system ( tag::Lagrange, tag::of_degree, 1 );
	Function x = xy[0], y = xy[1];

	// define two actions on RR2 (translations)
	Manifold::Action g1 ( tag::transforms, xy, tag::into, (x+1.) && y ),
	                 g2 ( tag::transforms, xy, tag::into, (x+0.5) && (y+1.) );

	// and divide RR2 by the group of translations generated by {g1,g2}
	Manifold torus_manif = RR2 .quotient ( g1, g2 );

	Cell A ( tag::vertex );  x(A) = 0. ;  y(A) = 0.;
	Cell B ( tag::vertex );  x(B) = 0.5;  y(B) = 0.;

	Mesh AB = Mesh::Build ( tag::grid ) .shape ( tag::segment )
	  .start_at ( A ) .stop_at ( B ) .divided_in ( 5 );  // zero winding
	Mesh BA1 = Mesh::Build ( tag::grid ) .shape ( tag::segment )
		.start_at ( B ) .stop_at ( A ) .divided_in ( 5 ) .winding ( g1 );
	Mesh BA2 = Mesh::Build ( tag::grid ) .shape ( tag::segment )
		.start_at ( B ) .stop_at ( A ) .divided_in ( 10 ) .winding ( g2 );
	Mesh AB2 = Mesh::Build ( tag::grid ) .shape ( tag::segment )
		.start_at ( A ) .stop_at ( B ) .divided_in ( 10 ) .winding ( g2 - g1 );

	Mesh sq1 = Mesh::Build ( tag::grid ) .shape ( tag::rectangle )
		.faces ( AB, BA2, BA1.reverse(), AB2 .reverse() ) .winding();
	Mesh sq2 = Mesh::Build ( tag::grid ) .shape ( tag::rectangle )
		.faces ( BA2 .reverse(), BA1, AB2, AB .reverse() ) .winding();
	Mesh torus = Mesh::Build ( tag::join ) .meshes ( { sq1, sq2 } );

	std::vector < Cell > vec;
	Mesh::Iterator it = torus .iterator ( tag::over_cells, tag::of_dim, 2, tag::around, B );
	for ( it .reset(); it .in_range(); it++ )  vec .push_back ( *it );
	std::vector < Cell > ::iterator itv;
	for ( itv = vec .begin(); itv != vec .end(); itv++ )
	{	Cell sq = *itv;  sq .remove_from ( torus );  }

	// we can draw an unfolded mesh
	torus .export_to_file ( tag::eps, "torus.eps", tag::unfold,
	                        tag::over_region, -2. < x < 1.7, -0.4 < y < 1.5 );
	std::cout << "produced file torus.eps - please edit before viewing" << std::endl;

}  // end of main
